/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.client.internal.PostPlanSaveRunnable"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.SaveRunnable"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$

(function() {

var ServiceResponseHandler			= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var PlanningClient					= com.ibm.team.apt.web.client.internal.PlanningClient;

dojo.declare("com.ibm.team.apt.web.client.internal.PostPlanSaveRunnable", //$NON-NLS-1$
		[com.ibm.team.apt.web.client.internal.SaveRunnable], {
	
	_plan: null,
	_planMode: null,
	
	constructor: function(plan, planMode) {
		this._plan= plan;
		this._planMode= planMode;
	},

	save: function(successCallback, failureCallback) {
		var serviceObj= {
				self: this,

				success: function(result) {
					successCallback();
				},
				failure : function(operationReport) {
					failureCallback(operationReport);
				}
		};
		var responseHandler= new ServiceResponseHandler(serviceObj, "success", "failure"); //$NON-NLS-1$ //$NON-NLS-2$
		PlanningClient.postModifyPlanStore(responseHandler, this._plan, this._planMode);
	},
	
	undo: function() {
	},
	
	canMergeWith: function(runner) {
		return runner instanceof com.ibm.team.apt.web.client.internal.PostPlanSaveRunnable;
	},
	
	mergeWith: function(runner) {
	},

	__sentinel: null // terminates this class definition
});

})();