/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.ImageIconItem");

/*
 * Imports 
 */
dojo.require("jazz.ui.Tree");
dojo.require("jazz.ui.tree.AbstractItem");


(function() {

/*
 * Aliases
 */
var AbstractItem = jazz.ui.tree.AbstractItem;

/*
 * Class 
 */
dojo.declare("com.ibm.team.dashboard.web.ui.internal.ImageIconItem",
	[AbstractItem, dijit._Templated], {
	
	templateString: "<div class='simpleItem'><img dojoAttachPoint='_icon' class='icon'/><div dojoAttachPoint='_label' class='label'></div></div>",

	/*
 	 * Public Method
 	 * 
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */		
	postCreate: function() {
		this.inherited(arguments);
		// Icon Class
		if (this.iconClass) {
			this._icon.className = this._icon.className + " " + this.iconClass;
		}
		// Icon Alt
		if (this.iconAlt) {
			this._icon.alt = this.iconAlt;
		}
		// Icon Src
		if (this.iconSrc) {
			this._icon.src = this.iconSrc;
		}
		
		// Label Class
		if (this.labelClass) {
			this._label.className = this._label.className + " " + this.labelClass;
		}
		// Label Content
		this._label.innerHTML = this.label;
	},

	/*
 	 * Public Method
 	 * 
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */		
	update: function() {
		// NO-OP
	},

	/*
 	 * Public Method
 	 * 
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */		
	destroy: function() {
		this.inherited(arguments);
	}
	
});

})();
	
	