/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportsView");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.SideNavigationLayout");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.core.internal.loader"); //$NON-NLS-1$

dojo.require("com.ibm.team.reports.web.ui.internal.ReportsController");
dojo.require("com.ibm.team.reports.web.ui.internal.AdminNavigator");
dojo.require("com.ibm.team.reports.web.ui.internal.IncludeArchived");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportsNavigator");
//dojo.require("com.ibm.team.reports.web.ui.internal.ReportTemplatesNavigator");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportViewer");
dojo.require("com.ibm.team.reports.web.ui.internal.NewReportEditor");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportTemplateManagement");
dojo.require("com.ibm.team.reports.web.ui.internal.WorkItemsNavigator");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportsWelcome");
dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");
dojo.require("com.ibm.team.reports.web.client.internal.AdminPageRegistry");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() { // module container

var session	= com.ibm.team.repository.web.client.session;
var ReportsClient = com.ibm.team.reports.web.client.internal.ReportsClient;
var WorkItemsNavigator = com.ibm.team.reports.web.ui.internal.WorkItemsNavigator;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var AdminPageRegistry = com.ibm.team.reports.web.client.internal.AdminPageRegistry;
var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var ActionRegistry = null; // Initialize later
var newReportURI = "#action=com.ibm.team.reports.newReport";
var manageTemplatesURI = "#action=com.ibm.team.reports.newReport";
var loader = jazz.core.internal.loader;

/**
 * Main perspective view for the Reports perspective.
 */
dojo.declare("com.ibm.team.reports.web.ui.internal.ReportsView", [dijit._Widget, dijit._Templated], {
		templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportsView.html"),
		
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},

		postCreate: function() {
			com.ibm.team.reports.web.ui.internal.ReportsView.superclass.postCreate.apply(this);

		 	this.controller = new com.ibm.team.reports.web.ui.internal.ReportsController(this);
		    this._mainView = new net.jazz.ajax.ui.SideNavigationLayout({}, this._appContainer);
		    this.parentController = this._mainView.controller;
		    
		 	this.controller.parentController = this._mainView.controller; 
		 	this.controller.prototype = this._mainView.controller;
		 	
		 	// Lazy initialize ActionRegistry
		 	ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
		 	
			ActionRegistry.registerAction("com.ibm.team.reports.defaultAction", this.getController(), "defaultAction");
			ActionRegistry.registerAction("com.ibm.team.reports.viewQuery", this.getController(), "viewQuery");
			ActionRegistry.registerAction("com.ibm.team.reports.viewReport", this.getController(), "viewReport");
			ActionRegistry.registerAction("com.ibm.team.reports.getMyQueries", this.getController(), "getMyQueries");
			ActionRegistry.registerAction("com.ibm.team.reports.getSharedQueries", this.getController(), "getSharedQueries");
			ActionRegistry.registerAction("com.ibm.team.reports.admin", this.getController(), "admin");
		 	ActionRegistry.registerAction("com.ibm.team.reports.viewWorkItems", this.getController(), "viewWorkItems");
		 	ActionRegistry.registerAction("com.ibm.team.reports.newReport", this.getController(), "newReport");
			//ActionRegistry.registerAction("com.ibm.team.reports.manageTemplates", this.getController(), "manageTemplates");
		 	
		    this._canDeployQuery = false;
		    this._canManageFolder = false;
		    this._canSeeReports = false;
		    this._showWelcome = false;
		    // The number of asnyc calls below we need to wait for
		    this._numberOfPendingResponses = 4;
			var responseHandler = new ServiceResponseHandler(
				this,
				"_handleCanDeployQuery",
				"_remoteError");
			ReportsClient.getCanDeployQuery(responseHandler);
			responseHandler = new ServiceResponseHandler(
				this,
				"_handleCanManageFolder",
				"_remoteError");
			ReportsClient.getCanManageFolder(responseHandler);
			responseHandler = new ServiceResponseHandler(
					this,
					"_handleCanSeeReports",
					"_remoteError");
			ReportsClient.getCanSeeReports(responseHandler);
			responseHandler = new ServiceResponseHandler(
				this,
				"_handleGetDefaultQueryDescriptor",
				"_remoteError");
			ReportsClient.getDefaultQueryDescriptor(responseHandler);
		},
		
		/**
		 * Framework API for hyperlinks and back/forward.
		 */
		getController: function() {
			return this.controller;
		},
		
		_handleGetDefaultQueryDescriptor: function(result) {
			this.controller.setDefaultQuery(result);
			this._numberOfPendingResponses--;
			if (this._numberOfPendingResponses > 0) {
				return;
			}
			this._initializeNavigation();
		},
		
		_handleCanDeployQuery: function(result) {
			if (result == "true") {
				this._canDeployQuery = true;
			}
			this._numberOfPendingResponses--;
			if (this._numberOfPendingResponses > 0) {
				return;
			}
			this._initializeNavigation();
		},
		
		_handleCanManageFolder: function(result) {
			if (result == "true") {
				this._canManageFolder = true;
			}
			this._numberOfPendingResponses--;
			if (this._numberOfPendingResponses > 0) {
				return;
			}
			this._initializeNavigation();		
		},
		
		_handleCanSeeReports: function(result) {
			if (result == "true") {
				this._canSeeReports = true;
			}
			this._numberOfPendingResponses--;
			if (this._numberOfPendingResponses > 0) {
				return;
			}
			this._initializeNavigation();		
		},
		
		/**
		 * Initializes the left navigation section.
		 */
		_initializeNavigation: function() {
			if (!this._canSeeReports) {
				return;
			}
			if (!com.ibm.team.repository.web.client.session.isGuest() && this._canDeployQuery) {
				this._newReportCommand = this._mainView.addCommand({href: newReportURI, imageClass: "create-report-command", buttonText: this.messages.createReport, boldFirstWord: true, size: "small"});
			}
		
			if (this._canDeployQuery) {
				var myWidget = new com.ibm.team.reports.web.ui.internal.ReportsNavigator({controller: this.controller, shared: false, canDeployQuery: this._canDeployQuery, canManageFolder: this._canManageFolder, defaultQuery: this.controller.getDefaultQuery()});
				this._myReportsNavigator = myWidget;
				var navSection = this._mainView.addNavigationSection(myWidget.domNode, this.messages.myReports, true);
				if (this._canManageFolder) {
					this._myReportsNavigator.initializePulldown(navSection);
				}
				this.controller.initializeMyReportsNavigator(myWidget);
			}
			
			var sharedWidget = new com.ibm.team.reports.web.ui.internal.ReportsNavigator({controller: this.controller, shared: true, canDeployQuery: this._canDeployQuery, canManageFolder: this._canManageFolder, defaultQuery: this.controller.getDefaultQuery()});
			this._sharedReportsNavigator = sharedWidget;
			navSection = this._mainView.addNavigationSection(sharedWidget.domNode, this.messages.sharedReports, true);
			if (this._canManageFolder) {
				this._sharedReportsNavigator.initializePulldown(navSection);
			}
			this.controller.initializeSharedReportsNavigator(sharedWidget);
			
			//var templatesWidget = new com.ibm.team.reports.web.ui.internal.ReportTemplatesNavigator({});
			//var templatesNavSection = this._mainView.addNavigationSection(templatesWidget.domNode, "Report Templates", true);

			var responseHandler = new ServiceResponseHandler(
				this,
				"_handleIsDWAdmin",
				"_remoteError");
			ReportsClient.getIsDWAdmin(responseHandler);
			
			// Include Archived checkbox
			var archivedWidget = new com.ibm.team.reports.web.ui.internal.IncludeArchived({controller: this.controller});
			//this._mainView._leftNav.appendChild(archivedWidget.domNode);
			this._mainView.addNavigationSection(archivedWidget.domNode, null, true);
			if (this._showWelcome) {
				this.showWelcome();
			}
		},
		
		_handleIsDWAdmin: function(isDWAdmin) {
			var allPages = AdminPageRegistry.getContributedPages();
			var pages = allPages;
			if (isDWAdmin == "false") {
				pages = [];
				for (var i = 0; i < allPages.length; i++) {
					var page = allPages[i];
					if (page.visibility == "public") {
						pages.push(page);
					}
				}
			}
			if (pages.length == 0) {
				return;
			}
			var widget = new com.ibm.team.reports.web.ui.internal.AdminNavigator
				({controller: this.controller, pages: pages});
			this._adminNavigator = widget;
			this._mainView.addNavigationSection(widget.domNode, this.messages.admin, true);
		},

		// show methods to be called from ReportsController
		
		showQuery: function(args) {
			if (this._reportViewer) {
				this._reportViewer.destroy();
			}
			if (args.name) {
				PlatformUI.getWorkbench().setTitle(this.messages.reportColon + args.name);
			} else {
				PlatformUI.getWorkbench().setTitle(this.messages.report);
			}
			this._reportViewer = new com.ibm.team.reports.web.ui.internal.ReportViewer({queryUUID: args.queryUUID, controller: this.controller, reportTitle: args.name}, null);
			this._mainView.setMainContent(this._reportViewer.domNode);
			if (this._myReportsNavigator) {
				this._myReportsNavigator.setSelection({queryUUID: args.queryUUID});
			}
			if (this._sharedReportsNavigator) {
				this._sharedReportsNavigator.setSelection({queryUUID: args.queryUUID});
			}
			if (this._adminNavigator) {
				this._adminNavigator.setSelection(null);
			}			
		}, 
		
		showReport: function(args) {
			var projectAreaUUID = "";
			if (args.projectAreaUUID) {
				projectAreaUUID = args.projectAreaUUID;
			}
			var queryUUID = "";
			if (args.queryUUID) {
				queryUUID = args.queryUUID;
			}
			PlatformUI.getWorkbench().setTitle(this.messages.report);
			var reportViewer = new com.ibm.team.reports.web.ui.internal.ReportViewer
				({projectAreaUUID: projectAreaUUID, 
				  reportUUID: args.reportUUID, 
				  queryUUID: queryUUID, 
				  parameterName: args.parameterName, 
				  parameterValue: args.parameterValue, 
				  controller: this.controller});
			this._mainView.setMainContent(reportViewer.domNode);
			if (this._myReportsNavigator != null && this._myReportsNavigator != undefined) {
				this._myReportsNavigator.setSelection(null);
			}
			if (this._sharedReportsNavigator != null && this._sharedReportsNavigator != undefined) {
				this._sharedReportsNavigator.setSelection(null);
			}
			if (this._adminNavigator) {
				this._adminNavigator.setSelection(null);
			}
		}, 
		
		showWelcome: function() {
			if (this._numberOfPendingResponses > 0) {
				this._showWelcome = true;
				return;
			}
			if (!this._canSeeReports) {
				return;
			}
			this._showWelcome = false;
			var welcomePageWidget = new com.ibm.team.reports.web.ui.internal.ReportsWelcome({});
			this._mainView.setMainContent(welcomePageWidget.domNode);
		},
		
		newReport: function(args) {
			PlatformUI.getWorkbench().setTitle(this.messages.newReport);
			var newReportEditor = new com.ibm.team.reports.web.ui.internal.NewReportEditor({controller: this.controller});
			this._mainView.setMainContent(newReportEditor.domNode);
			if (this._myReportsNavigator != null && this._myReportsNavigator != undefined) {
				this._myReportsNavigator.setSelection(null);
			}
			if (this._sharedReportsNavigator != null && this._sharedReportsNavigator != undefined) {
				this._sharedReportsNavigator.setSelection(null);
			}
			if (this._adminNavigator) {
				this._adminNavigator.setSelection(null);
			}
		},
		
		admin: function(args) {
			var pages = AdminPageRegistry.getContributedPages();
			for (var i = 0; i < pages.length; i++) {
				var page = pages[i];
				if (page.id == args.id) {
					PlatformUI.getWorkbench().setTitle(page.name);
					if (dojo.exists(page.widgetId)) {
						this._showWidget(page.widgetId);
					} else {
						loader.load_async(page.widgetId, dojo.hitch(this, function() {
							this._showWidget(page.widgetId);
						}));
					}
					break;
				}
			}
			if (this._myReportsNavigator) {
				this._myReportsNavigator.setSelection(null);
			}
			if (this._sharedReportsNavigator) {
				this._sharedReportsNavigator.setSelection(null);
			}
			if (this._adminNavigator) {
				this._adminNavigator.setSelection(args.id);
			}
		},
		
		_showWidget: function(widgetId) {
			var ctor = dojo.getObject(widgetId);
			var adminViewer = new ctor({controller: this.controller});
			this._mainView.setMainContent(adminViewer.domNode);
		},
	
		viewWorkItems: function(args) {
			WorkItemsNavigator.viewWorkItems(args);
		},
		
		_remoteError: function(error) {
			// Check if the content is still displaying
			if (!dojo.isDescendant(this._appContainer, document.body)) {
				// Not still displaying, ignore the error
				return;
			}
			alert(error.message);
		}
	}
);

})();