/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.viewlets.web.ui.internal.StartViewlet");

/*
 * Imports 
 */
dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");

(function() {
	
/*
 * Aliases 
 */
var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;

/*
 * TODOs
 */
// Re-evaluate imports
// Re-evaluate aliases
// Add preview image to plugin.xml
// Add title hyperlink URL
// Add repository version 
// Add breaking non-visible whitespace only to FF - shows up as blocks in IE6

/*
 * Class 
 */
dojo.declare("com.ibm.team.dashboard.viewlets.web.ui.internal.StartViewlet",
	Viewlet, {
	
	/*
	 * Template
	 */	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.viewlets.web", "ui/internal/templates/StartViewlet.html"),

	/*
	 * Static Variable Container 
	 */
	_static: function() {}, 
	
	// Viewlet Methods -------------------------------------------------------->
	
	/*
 	 * Public Method
 	 * 
 	 * @param void
 	 * @return void
 	 * @overrides super
 	 */		
	init: function() {

		// Static Variables //------------------------------------------------->

		this._initializeStaticConstants();

		// Instance Variables //----------------------------------------------->
		
		this._viewletID = this._static._instanceCount;
		
	},	

	/*
 	 * Public Method
 	 * 
 	 * Called to update viewlet content (e.g. Settings changed)
 	 * 
 	 * @return <none>
 	 * @overrides super
 	 */	
	refresh: function() {
		// NO-OP
	},

	/*
 	 * Public Method
 	 * 
 	 * Called to update UI (e.g. Zoom)
 	 * 
 	 * @param <none>
 	 * @return <none>
 	 * @overrides super
 	 */	
	update: function() {
		// NO-OP
	},

	/*
 	 * Public Method
 	 * 
 	 * @param <none>
 	 * @return String
 	 * @overrides super
 	 */	
	getTitleHyperlinkURL: function() {
		return "TODO";
	},

	// Utility Methods -------------------------------------------------------->
	
	/*
 	 * Private Method
 	 * 
 	 * @param <none>
 	 * @return <none>
 	 */	
	_initializeStaticConstants: function() {

		// Track the number of viewlet instances
		if (this._static._instanceCount == undefined) {
			this._static._instanceCount = 1;
			// Proceed to initialize static constants
		} else {
			this._static._instanceCount++;
			// Static constants already initialized
			return;
		}

		this._static._CLASSNAME = "com.ibm.team.dashboard.viewlets.web.ui.internal.StartViewlet";
	},		
	
	// Private Methods -------------------------------------------------------->


	
	// Class Methods ---------------------------------------------------------->
	
	/*
 	 * Public Method
 	 * 
 	 * @param void
 	 * @return String
 	 */		
	toString: function() {
		return this._static._CLASSNAME;
	}

});


})();

