/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.users.WorkEnvironmentEditorPage"); //$NON-NLS-1$

/*
 * Imports 
 */
dojo.require("dojox.data.dom"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require("dojox.uuid.generateRandomUuid"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.ui.internal.admin.users.ProfileEditorPage"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.ResourcePlanningClient"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.users.model.AbsencesModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.users.model.Absence"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.users.dialogs.AbsenceEditDialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.viewers.TableViewer"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.users.WorkDayLabelProvider"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.users.WorkDayContentProvider"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.users.WorkDayColumnProvider"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.viewers.TableTreeViewer"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.users.AssignmentLabelProvider"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.users.AssignmentContentProvider"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.users.AssignmentColumnProvider"); //$NON-NLS-1$

(function() {

var ProfileEditorPage 		= com.ibm.team.repository.web.ui.internal.admin.users.ProfileEditorPage;
var ResponseHandler			= com.ibm.team.repository.web.transport.ServiceResponseHandler;

var ResourcePlanningClient	= com.ibm.team.apt.web.client.internal.ResourcePlanningClient;

var AbsencesModel			= com.ibm.team.apt.web.ui.internal.users.model.AbsencesModel;
var Absence					= com.ibm.team.apt.web.ui.internal.users.model.Absence;

var TableViewer				= com.ibm.team.apt.web.ui.internal.viewers.TableViewer;
var WorkDayLabelProvider	= com.ibm.team.apt.web.ui.internal.users.WorkDayLabelProvider;
var WorkDayContentProvider	= com.ibm.team.apt.web.ui.internal.users.WorkDayContentProvider;
var WorkDayColumnProvider	= com.ibm.team.apt.web.ui.internal.users.WorkDayColumnProvider;

var TableTreeViewer				= com.ibm.team.apt.web.ui.internal.viewers.TableTreeViewer;
var AssignmentLabelProvider	= com.ibm.team.apt.web.ui.internal.users.AssignmentLabelProvider;
var AssignmentContentProvider	= com.ibm.team.apt.web.ui.internal.users.AssignmentContentProvider;
var AssignmentColumnProvider	= com.ibm.team.apt.web.ui.internal.users.AssignmentColumnProvider;

var AbsenceEditDialog		= com.ibm.team.apt.web.ui.internal.users.dialogs.AbsenceEditDialog;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.users.WorkEnvironmentEditorPage", //$NON-NLS-1$
	[ProfileEditorPage], {

	// Properties //----------------------------------------------------------->

	templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/users/templates/WorkEnvironmentEditorPage.html"), //$NON-NLS-1$ //$NON-NLS-2$
	
	/* time zone drop down */
	__timeZoneSelect: null,
	/* region drop down */
	__regionSelect: null,
	/* externalized messages for the template */
	__messages: MSGS,
	/* time zone infos */
	__timeZones: null,
	/* region infos */
	__regions: null,
	/* work environment info */
	__workEnvironment: null,
	
	/* attach point for the work days viewer */
	__workDayTable: null,
	/* viewer for the working days */
	__workDaysViewer: null,
	
	/* attach point for the assignment viewer */
	__assignmentTable: null,
	/* viewer for the work assignment */
	__assignmentViewer: null,
	
	__currentRegionId: null,
	__currentTimeZoneId: null,
	
	// Public Methods //------------------------------------------------------->
	
	constructor: function(args) {
	},
	
	postCreate: function() {
		this.inherited(arguments);
	
		this.__regionSelect.contentEditable= false;
		this.connect(this.__regionSelect, "onchange", dojo.hitch(this, function(e) { //$NON-NLS-1$
			var target= e.target;
			var index= target.selectedIndex;
			var option= target.options[index];
			this.__currentRegionId= option.value;
			
			this.setDirty(true);
			
			this.__workDaysViewer.refresh();
		}));
		
		this.__timeZoneSelect.contentEditable= false;
		this.connect(this.__timeZoneSelect, "onchange", dojo.hitch(this, function(e) { //$NON-NLS-1$
			var target= e.target;
			var index= target.selectedIndex;
			var option= target.options[index];
			this.__currentTimeZoneId= option.value;
			
			this.setDirty(true);
		}));
		
		this.__workDaysViewer= new TableViewer(TableViewer.constructorArgs(
				["aptWETable"],  //$NON-NLS-1$
				new WorkDayLabelProvider(), 
				new WorkDayContentProvider(), 
				new WorkDayColumnProvider()
		));
		this.__workDayTable.appendChild(this.__workDaysViewer.domNode);
		this.__workDaysViewer.setComparator(dojo.hitch(this, function(workDay1, workDay2) {
			var firstDay= -1;
			if (this.__regions && this.__currentRegionId) {
				var region= this.__findRegion(this.__currentRegionId);
				if (region)
					firstDay= region.firstWorkDay;
			} else if (this.__workEnvironment && this.__workEnvironment.region) {
				firstDay= this.__workEnvironment.region.firstWorkDay;
			}
			
			var firstValue= workDay1.day;
			if (firstDay >= 0) {
				if (firstDay - firstValue > 0)
					firstValue+= 7;
			}
			var secondValue= workDay2.day;
			if (firstDay >= 0) {
				if (firstDay - secondValue > 0)
					secondValue+= 7;
			}
			
			return firstValue - secondValue;
		}));
		
		this.__assignmentViewer= new TableTreeViewer(TableTreeViewer.constructorArgs(
				["aptWETable", "aptAssignmentTable"],  //$NON-NLS-1$ //$NON-NLS-2$
				new AssignmentLabelProvider(), 
				new AssignmentContentProvider(), 
				new AssignmentColumnProvider()
		));
		this.__assignmentTable.appendChild(this.__assignmentViewer.domNode);
		this.__assignmentViewer.setComparator(dojo.hitch(this, function(e1, e2) {
			var labelProvider= this.__assignmentViewer.getLabelProvider();
			var l1= labelProvider.getLabel(e1, 0);
			var l2= labelProvider.getLabel(e2, 0);
				
			return l1.localeCompare(l2);
		}));
		
		this.__fetchTimeZoneData();
		this.__fetchRegionData();
		this.__fetchWorkEnvironmentInfo();
	},
		
	destroy: function() {
		
		this.inherited(arguments);
	},
	
	doSave: function(callback) {
		if (!this.__workEnvironment)
			return;
		
		var totalBooking= this.__workEnvironment.workAssignment.percentage;
		if (totalBooking > 100) {
			callback(this.pageID, {message: bind(MSGS.USER_EDITOR_ENVIRONMENT_ASSIGNMENT_SAVE_ERROR, [totalBooking - 100])});
			this.inherited(arguments);
			return;
		}
			
		var context = this;
		var serviceCallback= {
			_success: function(result) {
				callback(context.pageID);
				context.refresh();
			},
			_error: function(error) {
				callback(context.pageID, error);
			}
		};
		
		var workDayDTOs= new Array();
		for ( var i = 0; i < this.__workEnvironment.workDays.length; i++) {
			var workDay= this.__workEnvironment.workDays[i];
			workDayDTOs.push(dojo.toJson({
				day: workDay.day,
				workingTime: workDay.workingTime,
				endTime: (60 * workDay.endDate.getHours() + workDay.endDate.getMinutes()) * 60 * 1000
			}));	
		}
		
		var workAssignmentDTOs= new Array();
		this.__createAssignmentDTOs(this.__workEnvironment.workAssignment, workAssignmentDTOs);
		
		var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$
		ResourcePlanningClient.postWorkEnvironment(responseHandler, this.itemUUID, this.__currentRegionId, this.__currentTimeZoneId, workDayDTOs, workAssignmentDTOs);
		
		this.inherited(arguments);
	},

	refresh: function() {
		this.__fetchWorkEnvironmentInfo();
	},

	// Private Methods //------------------------------------------------------>
	
	__fetchWorkEnvironmentInfo: function() {
		this.__disableSelect(this.__timeZoneSelect);
		this.__disableSelect(this.__regionSelect);
		
		this.__workEnvironment= null;
		
		this.__updateAssignmentLabel();
		
		this.__workDaysViewer.setMessage(MSGS.USER_EDITOR_PENDING);
		this.__assignmentViewer.setMessage(MSGS.USER_EDITOR_PENDING);
		
		var _self= this;
		var serviceCallback= {
			_success: function(result) {
				_self.__workEnvironment= result;
				
				_self.__update();
			},
			_error: function(error) {
				console.log(error);
			}
		};
		
		var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$		
		ResourcePlanningClient.fetchWorkEnvironmentInfo(responseHandler, this.itemUUID);
	},
	
	__fetchTimeZoneData: function() {
		this.__disableSelect(this.__timeZoneSelect);
		
		var _self= this;
		var serviceCallback= {
			_success: function(result) {
				_self.__timeZones= result;
				
				_self.__update();
			},
			_error: function(error) {
				console.log(error);
			}
		};
		
		var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$		
		ResourcePlanningClient.fetchTimeZoneData(responseHandler);
	},
	
	__fetchRegionData: function() {		
		this.__disableSelect(this.__regionSelect);
		
		var _self= this;
		var serviceCallback= {
			_success: function(result) {
				_self.__regions= result;
				
				_self.__update();
			},
			_error: function(error) {
				console.log(error);
			}
		};
		
		var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$		
		ResourcePlanningClient.fetchRegionData(responseHandler);
	},
	
	__update: function() {
		if (!this.__regions)
			return;
		if (!this.__timeZones)
			return;
		if (!this.__workEnvironment)
			return;

		var timeZoneId= this.__workEnvironment.timeZone ? this.__workEnvironment.timeZone.itemId : null;
		this.__fillSelect(this.__timeZoneSelect, this.__timeZones, timeZoneId);
		
		var regionId= this.__workEnvironment.region ? this.__workEnvironment.region.itemId : null;
		this.__fillSelect(this.__regionSelect, this.__regions, regionId);
		
		var workDays= this.__workEnvironment.workDays;
		this.__massageWorkDays(workDays);
		this.__workDaysViewer.setInput(workDays);
		
		var workAssignment = this.__workEnvironment.workAssignment;
		this.__massageAssignment(workAssignment, null);
		this.__updateAssignmentLabel();
		this.__assignmentViewer.setInput(workAssignment);
	},
	
	__massageWorkDays: function(workDays) {
		var timeZoneOffset= new Date(0).getTimezoneOffset() * 60 * 1000;
		for ( var i = 0; i < workDays.length; i++) {
			var workDay= workDays[i];
			workDay.markChanged= dojo.hitch(this, function() {
				this.setDirty(true);
				
				this.__workDaysViewer.refresh();
			});
			workDay.timeZoneOffset= timeZoneOffset;
			workDay.endDate= new Date(workDay.endTime + workDay.timeZoneOffset);
		}
	},
	
	__massageAssignment: function(assignment, parent) {
		assignment.markChanged= dojo.hitch(this, function() {
			this.setDirty(true);
			
			this.__calculateAssignment(assignment.parent);
			this.__updateAssignmentLabel();
			this.__assignmentViewer.refresh();
		});
		
		assignment.parent= parent;
		
		var children= assignment.children;
		if (children) {
			assignment.hasChildren= true;
			for ( var i = 0; i < children.length; i++) {
				this.__massageAssignment(children[i], assignment);
			}
		} else {
			assignment.children= new Array();
			assignment.hasChildren= false;
		}
	},
	
	__calculateAssignment: function(assignment) {
		if (!assignment)
			return;
		
		if (assignment.hasChildren) {
			var children= assignment.children;
			var sum= 0;
			for ( var i = 0; i < children.length; i++) {
				sum+= children[i].percentage;
			}
			assignment.percentage= sum;
		}
		
		this.__calculateAssignment(assignment.parent);
	},
	
	__createAssignmentDTOs: function(assignment, result) {
		if (assignment.itemId) {
			result.push(dojo.toJson({
				itemId: assignment.itemId,
				percentage: assignment.percentage,
				isNewItem: assignment.isNewItem,
				lineId: assignment.lineId,
				ownerId: assignment.ownerId
			}));
		}
		
		var children= assignment.children;
		for ( var i = 0; i < children.length; i++) {
			this.__createAssignmentDTOs(children[i], result);
		}
	},
	
	__updateAssignmentLabel: function() {
		if (this.__workEnvironment) {
			this.__assignmentLable.innerHTML= bind(MSGS.USER_EDITOR_ENVIRONMENT_ASSIGNMENT_SUMMARY_2, [this.__workEnvironment.workAssignment.percentage]);
		} else {
			this.__assignmentLable.innerHTML= MSGS.USER_EDITOR_ENVIRONMENT_ASSIGNMENT_SUMMARY;
		}
	},
	
	__disableSelect: function(select) {
		dojox.data.dom.removeChildren(select);
		
		optionNode= document.createElement("option"); //$NON-NLS-1$
		optionNode.appendChild(document.createTextNode(MSGS.USER_EDITOR_PENDING));
		select.appendChild(optionNode);
		
		select.disabled= true;
	},
	
	__fillSelect: function(select, data, itemId) {
		dojox.data.dom.removeChildren(select);
		
		var selectIndex= -1;
		for ( var i = 0; i < data.length; i++) {
			var optionNode= document.createElement("option"); //$NON-NLS-1$
			
			optionNode.appendChild(document.createTextNode(data[i].label));
			optionNode.value= data[i].itemId;
			if (data[i].itemId == itemId)
				selectIndex= i;
			
			select.appendChild(optionNode);
		}
		
		select.selectedIndex= selectIndex;
		
		select.disabled= false;
	},
	
	__findRegion: function(id) {
		for ( var i = 0; i < this.__regions.length; i++) {
			if (id == this.__regions[i].itemId)
				return this.__regions[i];
		}
		
		return null;
	},
			
	__sentinel: null // terminates this class definition
	
});

})();
