/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.build.web.ui.internal.utils.ErrorUtil");

dojo.require("dojo.string");
dojo.require("dojo.i18n");
dojo.require("jazz.util.html");
dojo.requireLocalization("com.ibm.team.build.web.ui.internal", "BuildMessages");

(function() {

var messages = dojo.i18n.getLocalization("com.ibm.team.build.web.ui.internal", "BuildMessages");

com.ibm.team.build.web.ui.internal.utils.ErrorUtil = {
	handleErrorResponse: function(response, notFoundMessage, wrapperMessage) {
		var msg = com.ibm.team.build.web.ui.internal.utils.ErrorUtil.getErrorMessage(response, notFoundMessage);
		if (wrapperMessage)
			msg = dojo.string.substitute(wrapperMessage, [msg]);
		com.ibm.team.build.web.ui.internal._buildPage.showErrorPage(msg);
	},
	handleErrorResponseAlert: function(response, notFoundMessage, wrapperMessage) {
		var msg = com.ibm.team.build.web.ui.internal.utils.ErrorUtil.getErrorMessage(response, notFoundMessage);
		if (wrapperMessage)
			msg = dojo.string.substitute(wrapperMessage, [msg]);
		alert(msg);
	},
	getErrorMessage: function(response, notFoundMessage) {
		var msg = notFoundMessage || messages.serviceNotFound;
		if (!response)
			return msg;
		if (response.status == 404) {
			// keep default message
		} else if (response.responseText) {
			var err = dojo.fromJson(response.responseText);
			if (err && err.errorMessage) {
				msg = jazz.util.html.escape(err.errorMessage);
			}
		} else if (response.message) {
			msg = jazz.util.html.escape(response.message);
		}
		return msg;
	}
};
})();
