/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.DeletePlanModeAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$

(function() {

var Action= com.ibm.team.apt.web.ui.internal.view.plan.actions.Action;	
var Assert= com.ibm.team.apt.web.ui.internal.common.Assert;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/delete.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.DeletePlanModeAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	
	
	_tab: null,
	
	constructor: function(tab) {
		this._tab= tab;
	},
	
	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getStyle: function() {
		return Action.STYLE_FLAT;
	},
	
	getId: function() {
		return "planmode.delete"; //$NON-NLS-1$
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	getName: function() {
		return MSGS.ACTION_PLAN_MODE_DELETE;
	},
	
	canHandle: function() {
		return this._tab.isResolved() && this._tab.getPlanMode().sharedPlanModeId != null;
	},
	
	handle: function(e) {
		if(!this.canHandle())
			return
		this._tab._onDeleteButton(e); // XXX implement action here
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
