/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.PromoteAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveRunnerExecuteAction"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {
	
var Assert							= com.ibm.team.apt.web.ui.internal.common.Assert;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/decrease_indent.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.PromoteAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveRunnerExecuteAction], {
	
	
	constructor: function(viewModel, itemMovePolicy, errorReporter) {
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "move.promote"; //$NON-NLS-1$
	},
	
	getName: function() {
		return MSGS.ACTION_MOVE_ELEMENT_PROMOTE;
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	canHandle: function() {
		if (this._isDisposed())
			return false;

		var targetEntry= this._viewerItem.getViewEntry();
		var selection= this._viewModel.getSelectedEntries();
		
		if (selection.length == 0 || (selection.length == 1 && selection[0] === targetEntry)) {
			return this._movePolicy.canMove(targetEntry, targetEntry, com.ibm.team.apt.ui.Move.Promote);
		}
		
		return false;
	},
	
	_doHandle: function() {
		var targetEntry= this._viewerItem.getViewEntry();
		var selection= this._viewModel.getSelectedEntries();

		var entry= targetEntry || selection[0];
		return this._movePolicy.move(entry, entry, com.ibm.team.apt.ui.Move.Promote);
	},

	_getPostOperationSelectionEntries: function() {
		return [];
	},

	__sentinel: null // terminates this class definition
});

})();
