/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.SaveErrorDialog"); //$NON-NLS-1$

dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.SaveErrorDialog", null, { //$NON-NLS-1$
	
	constructor: function(params){
		var widgetParams = { primaryTitle: bind(MSGS.DIALOGS_SAVE_ERROR_TITLE, [params.message]) };

		var onOk= dojo.hitch(this,function(attributes) {
			this.floatingPane.close();
		});
		
		this.contentWidget= new com.ibm.team.apt.web.ui.internal.view.plan.dialogs.SaveErrorDialogContent({
			onOk: onOk,  
			description: params.description
		});
		widgetParams.contentNode = this.contentWidget.domNode;
		this.floatingPane = new jazz.ui.Dialog(widgetParams); 
		this.contentWidget.init();
	}
	
});

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.SaveErrorDialogContent", //$NON-NLS-1$
	[dijit._Widget, dijit._Templated], {
	
	templateString: '<div style="padding: 1em 1em 1em 1em;">' + //$NON-NLS-1$
						'<div dojoAttachPoint="_contentNode" style="height: 20em; background-color: #FFFFFF; border: 1px solid #CCCCCC;"></div>' + //$NON-NLS-1$
						'<div style="padding: 1em 0em; float: right;">' + //$NON-NLS-1$
							'<button dojoAttachPoint="_okCmd">OK</button>' + //$NON-NLS-1$
						'</div>' + //$NON-NLS-1$
					' </div>', //$NON-NLS-1$
	
	constructor: function(params){
		this._onOk= params.onOk;
		this._description= params.description;
	},
	
	postCreate: function() {
		this.connect(this._okCmd, "onclick", this._onOk); //$NON-NLS-1$
		
		if (this._description) {
			this._contentNode.innerHTML= this._description;
		} else {
			this._contentNode.innerHTML= MSGS.DIALOGS_SAVE_ERROR_NO_DESCRIPTION;
		}
	},
	
	init: function() {
	}
	
});

})();
