/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.AttributeTree");

dojo.require("dijit._Templated");
dojo.require("jazz.ui.ModeledTree");
dojo.require("jazz.ui.tree.AbstractItem");
(function() {

var ModeledTree = jazz.ui.ModeledTree;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.IconItem", [jazz.ui.tree.AbstractItem, dijit._Templated], {
	
	templateString: "<div class='simpleItem'><div dojoAttachPoint='_icon' class='icon ${iconClass}'></div><div dojoAttachPoint='_label' class='${labelClass}'>${label}</div></div>",
	
	label:"",
	iconClass:"",
	labelClass: "label",
	
	update: function() {
		this._icon.className = "icon " + this.iconClass;
		this._label.innerHTML = this.label;
		this._label.className= this.labelClass;
	}
	
});

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.AttributeTree", ModeledTree, {

	postCreate: function() {
		this._childWidgets = [];
		this.inherited(arguments);
	},
	destroy: function() {
		for(var i=0;i<this._childWidgets.length;i++) {
			this._childWidgets[i].destroy();
		}
		this._childWidgets = [];
		this.inherited(arguments);
	},
	createTreeItem: function(/* AttributeDTO */ modelObj) {
		
		var descriptor= {
			iconClass: "com-ibm-team-workitem-queryeditor-attributeIcon",
			label: modelObj.label,
			labelClass: modelObj.isQueryable ? "label" : "disabled",
			item: modelObj
		};
		var iconItem = new com.ibm.team.workitem.web.ui.internal.view.queryeditor.IconItem(descriptor);
		this._childWidgets.push(iconItem);
		return iconItem;
	}
});

})();
	
	