/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.widgets.RelatedPlansWidget"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojox.data.dom"); //$NON-NLS-1$
dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.common.QueryDescriptor"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
var PlanningClient= com.ibm.team.apt.web.client.internal.PlanningClient;
var PlanningUtil= com.ibm.team.apt.web.client.util;
var CreatePlanIconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/crt_iteration_plan.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var empty= dojox.data.dom.removeChildren;
var bind= dojo.string.substitute;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.widgets.RelatedPlansWidget", //$NON-NLS-1$
			 [dijit._Widget, dijit._Templated], {

	
	constructor: function(args){
		this._query= PlanningUtil.createCustomQueryDescriptor("relatedToPlan", args.planRecord.itemId); //$NON-NLS-1$
		this._query._setResolvedRelatedItem(args.planRecord);
	},
	
	// ---- widget implementation ------------------------------------------------------------------------------------------

	templateString: "<div style='float: left; margin:0.3em; padding: 2px'><a href='#' dojoAttachPoint='_nodeRelatedPlans'>" + MSGS.ACTION_PLANS_RELATED + "</a></div>", //$NON-NLS-1$ //$NON-NLS-2$

	postCreate: function() {
		var $this= this;
		var $document= document;
		
		this.__doLoadRelatedPlans(function(result){
			empty($this._nodeRelatedPlans);
			$this._nodeRelatedPlans.appendChild($document.createTextNode(bind(MSGS.ACTION_PLANS_RELATED_COUNT, [result.results.length])));
		});
		
		this._nodeRelatedPlans.href= PlanningUtil.getSearchURI(this._query, false);
		
		var params= {
			around: this.domNode,
			html: "<span><div style='font-weight: bold; margin-bottom: 0.5em;'>" + MSGS.ACTION_PLANS_RELATED + "</div>" +  //$NON-NLS-2$ //$NON-NLS-1$
				"<div id='IterationPlanPage.RelatedPlans.Popup.Contents'></div>" + //$NON-NLS-1$
				"<div style='padding-top: 0.5em; border-top: 1px solid #C8DEE9; margin-top: 0.5em;'><a href='" + PlanningUtil.getPlanCreateURI() + "'> <img src='" + CreatePlanIconUrl + "'/> " + MSGS.ACTION_PLANS_CREATE + "<a/></div></span>", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
				
			onOpen: function(widget, time){
				if(this.__contentInitialized)
					return;
				
				var container= dojo.query("div[id='IterationPlanPage.RelatedPlans.Popup.Contents']", this.content)[0]; //$NON-NLS-1$
				empty(container);
				
				$this.__doLoadRelatedPlans(function(result){
					for (var i= 0; i < result.results.length; i++) {
						var plan= result.results[i];
						var link= $document.createElement("a"); //$NON-NLS-1$
						link.href= PlanningUtil.getPlanViewURI(plan.itemId);
						var img= $document.createElement("img"); //$NON-NLS-1$
						img.src= plan.iconURL;
						link.appendChild(img);
						link.appendChild($document.createTextNode(" " + bind(MSGS.ITERATIONPLAN_PLAN_LABEL, [plan.label, plan.getIteration().label]))); //$NON-NLS-1$
						var element= $document.createElement("div"); //$NON-NLS-1$
						element.appendChild(link);
						container.appendChild(element);
					}
					this.__contentInitialized= true;
				}, this);
				
			}
		};
		new jazz.ui.HoverPopup(params);
	},
	
	__doLoadRelatedPlans: function(callback, scope){
		if(this.__result){
			if(dojo.isFunction(callback)){
				callback.call(scope || this, this.__result);
			}
			return;
		}
		
		var $this= this;
		var serviceCallback= {
			_success: function(result){
				$this.__result= result;
				result.results.sort(function(a, b){
					a= a.getIteration();
					b= b.getIteration();
					
					if(a.backlog ^ b.backlog){
						return a.backlog ? 1 : -1;
					} else if(Boolean(a.endDate) && Boolean(b.endDate)){
						return a.endDate.beforeEq(b.endDate) ? -1 : 1;
					} else if(Boolean(a.startDate) && Boolean(b.startDate)){
						return a.startDate.beforeEq(b.startDate) ? -1 : 1;		
					} else if(Boolean(a.endDate) ^ Boolean(b.endDate)){
						return a.endDate ? -1 : 1;
					} else if(Boolean(a.startDate) ^ Boolean(b.startDate)) {
						return a.startDate ? -1 : 1;
					} else {
						return a.label.localeCompare(b.label);
					}
				});
				
				if(dojo.isFunction(callback)){
					callback.call(scope || $this, result);
				}
			},
			_error: function(e){
				console.info(e);
			}
		};
		var responseHandler= new com.ibm.team.repository.web.transport.ServiceResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$ 
		PlanningClient.searchIterationPlans(responseHandler, this._query, 0, 10);
	},
	
	__sentinel: null // terminates this class definition
});



})();
