/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

 // Use the jslint 'good things' default with the exception of: nomen: false (don't check variable names since dijit api uses _ which is against jslint rules) and forin
 /*jslint white: true, onevar: true, browser: true, undef: true, nomen: false, eqeqeq: true, plusplus: true, bitwise: true, regexp: true, strict: true, newcap: true, immed: true */
 /*global com, dijit, dojo, dojox, net, window, jazz */
 "use strict";

dojo.provide("com.ibm.team.scm.web.ui.internal.widgets.resourcesEditor.ResourceEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.ui.StyledBox");
dojo.require("jazz.ui.styledBox.TrimStyles");

dojo.require("com.ibm.team.scm.web.ui.internal.widgets.resourcesEditor.ResourcesEditor");

(function () {
	dojo.declare("com.ibm.team.scm.web.ui.internal.widgets.resourcesEditor.ResourceEditor", jazz.ui.StyledBox, {		
		constructor: function (args) {
			var contentNode;
			contentNode = document.createElement("div");
			this.editor = new com.ibm.team.scm.web.ui.internal.widgets.resourcesEditor.ResourcesEditor(
					args
				);
			/**
			 * When child container goes away, dispose this dialog
			 */
			dojo.connect(this.editor, "dispose", this, this.onChildClose);
			contentNode.appendChild(this.editor.domNode);
			this.contentNode = contentNode;
		},
		postCreate: function () {
			this.headerless = true;
			this.closable = false;
			this.trim = jazz.ui.styledBox.TrimStyles.EDITOR;
			this.inherited(arguments);
		},
		startup: function () {
			this.editor.startup();
		},
		onChildClose: function () {
			// StyledBox api - this invokes destroy
			this.close();
		},
		destroy: function() {
			if (this.editor) {
				this.editor.destroy();
				this.editor = null;
			}
			this.inherited(arguments);
		}

	});
}());