/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
dojo.provide("com.ibm.rational.cm.web.ui.view.common.sort");

dojo.mixin(com.ibm.rational.cm.web,
{
	// Compares arg1 to arg2, could be INT or String. Returns:
	// 1. -1 if arg1 < arg2.
	// 2. 0 if arg1 == arg2.
	// 3. 1 if arg1 > arg2.
	caseInsensitiveSort: function(arg1, arg2){
		if(!isNaN(arg1)){ // arg1 is a number
			if(!isNaN(arg2)){ // arg2 is a number
				return arg1 - arg2;
			}else{
				return -1; // arg1(number) before arg2(string)
			}
		}else if(!isNaN(arg2)){ // arg2 is number
			return 1;  // arg2(number) before arg1(string)
		}
		var upper1 = arg1.toUpperCase();
		var upper2 = arg2.toUpperCase();
		return upper1.localeCompare(upper2);   
	}
});