/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
 
 /* 
 * @description: com.ibm.rational.cm.web.ui.view.filter.CqTitlePane is a dojo widget extension for open/collapse navigation panes.
 *	
 *	CqTitlePane, will deal with open/collapse of navigation panes.
 *	
 *	@author Sreedhar Rella(srella@us.ibm.com)
 */
dojo.provide("com.ibm.rational.cm.web.ui.view.filter.CqTitlePane");

dojo.require("dijit.TitlePane");

dojo.declare(
	"com.ibm.rational.cm.web.ui.view.filter.CqTitlePane",
	dijit.TitlePane,
{
	/* Attribute to define whether this title pane should collapse when user clicks the title */
	isCollapsible: true,
		
	postCreate: function(){
		if(!this.isCollapsible){
			this.arrowNode.style.display = "none";
		}
		this.inherited("postCreate", arguments);
	},
	
	toggle: function(){
		if(!this.isCollapsible){ return; }
		this.inherited("toggle", arguments);
	}
});
