 /*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.action.ActionFactory"); //$NON-NLS-1$
dojo.require("jazz.core.internal.loader"); //$NON-NLS-1$


(function() {
	
com.ibm.team.workitem.web.ui2.internal.action.ActionFactory = {	
	/*
	 * Create a new action. 
	 *   action: (String) class name of the action
	 */
	getAction: function(createArgs /* actionSpec: { action }, workingCopy: workingCopy */) {
		
		var loadedAction = null;
		try{
			jazz.core.internal.loader.load_sync(createArgs.actionSpec.action);
			loadedAction = eval(createArgs.actionSpec.action);
		} catch(e){
			console.debug("Work Items could not load action: " + createArgs.actionSpec.action + " - " + e.message); //$NON-NLS-1$
			return null;
		}
		
		try{
			var result = new loadedAction(createArgs);
		} catch(e) {
			console.debug("Work Items could not create action: " + createArgs.actionSpec.action + " - " + e.message); //$NON-NLS-1$
			return null;
		}
		
		return result;
	}
};

})();