/******************************************************************************* 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.PlanningAttribute"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.PlanningAttributeIdentifier"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanningAttributeValueSet"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanningAttributeType"); //$NON-NLS-1$

(function() {

var PlanningAttributeValueSet		= com.ibm.team.apt.client.PlanningAttributeValueSet;
var PlanningAttributeType			= com.ibm.team.apt.client.PlanningAttributeType;

dojo.declare("com.ibm.team.apt.client.PlanningAttribute", com.ibm.team.apt.client.PlanningAttributeIdentifier, { //$NON-NLS-1$

	__descriptor: null,
	__valueSet: new PlanningAttributeValueSet([], undefined, undefined),

	constructor: function(descriptor) {
		this.__descriptor= descriptor;
		this.attributeType= PlanningAttributeType[descriptor.attributeType];
		this.readOnly= descriptor.readOnly;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	attributeType: null,
	readOnly: null,
	
	getLabel: function() {
		return this.__descriptor.name;
	},

	getQueryName: function() {
		return this.__descriptor.queryId || null;
	},
	
	getValueSet: function() {
		return this.__valueSet;
	},

	getValue: function(receiver) {
		throw new Error("can't read attribute " + this.__id); //$NON-NLS-1$
	},
	
	getParameter: function(key) {
		return this.__descriptor.parameters[key] || null;
	},
	
	setValue: function(receiver, value) {
		throw new Error("can't write attribute " + this.__id); //$NON-NLS-1$
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
