/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.common.Iteration"); //$NON-NLS-1$

//dojo.require("com.ibm.team.apt.internal.client.util.Iterations"); //$NON-NLS-1$
dojo.require("dojo.date.stamp"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.Instant"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore"); //$NON-NLS-1$


(function() {

var Instant							= com.ibm.team.apt.client.internal.Instant;
var ReferencedItemStore				= com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore;

dojo.declare("com.ibm.team.process.common.Iteration", null, { //$NON-NLS-1$

	constructor: function(iterationDTO, referencedItemStore) {
		this.itemId= iterationDTO.itemId;
		this.itemType= iterationDTO.itemType;
		this.label= iterationDTO.label;
		this.iconURL= iterationDTO.iconURL;
		this.startDate= iterationDTO.startDate != null ? new Instant(dojo.date.stamp.fromISOString(iterationDTO.startDate)) : null;
		this.endDate= iterationDTO.endDate != null ? new Instant(dojo.date.stamp.fromISOString(iterationDTO.endDate)) : null;
		this.archived= iterationDTO.archived;
		this.backlog= iterationDTO.backlog;
		this.current= iterationDTO.current;
		this.hasDeliverable= iterationDTO.hasDeliverable;
		this.children= iterationDTO.children;
		this.referencedItemStore= referencedItemStore;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	itemId: null,
	itemType: null,
	label: null,
	iconURL: null,
	startDate: null,
	endDate: null,
	archived: null,
	backlog: null,
	hasDeliverable: null,
	children: null, 
	referencedItemStore: null,
	
	getChildren: function(){
		return this.children ? dojo.map(this.children, function(child) { return this.referencedItemStore.getItem(ReferencedItemStore.ITEM_TYPES.ITERATION, child); }, this) : [];
	},
	
	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;
		
		return this.itemId == other.itemId;
	},

	compareTo: function(other) {
		return com.ibm.team.apt.internal.client.util.Iterations.compareTo(this, other);
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});


})();
