/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.common.ProcessArea"); //$NON-NLS-1$

(function() {


dojo.declare("com.ibm.team.process.common.ProcessArea", null, { //$NON-NLS-1$

	constructor: function(processAreaDTO) {
		this.itemId= processAreaDTO.itemId;
		this.itemType= processAreaDTO.itemType;
		this.label= processAreaDTO.label;
		this.iconURL= processAreaDTO.iconURL;
		this.archived= processAreaDTO.archived;
		this.getParent= processAreaDTO.getParent;
		this.getChildren= processAreaDTO.getChildren;
		this.getCategories= processAreaDTO.getCategories;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	itemId: null,
	itemType: null,
	label: null,
	iconURL: null,
	archived: null,
	
	getParent: function() {
		return null;
	},
	
	getChildren: function() {
		return null;
	},
	
	getCategories: function() {
		return null;
	},
	
	equals: function(other) {
		if (this === other)
			return true;
		
		if (!other)
			return false;

		if (this.declaredClass !== other.declaredClass)
			return false;
		
		return this.itemId == other.itemId;
	},

	compareTo: function(other) {
		if (this.label < other.label)
			return -1;
		if (this.label > other.label)
			return 1;    
		return 0;  
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
